package com.madeu.controller.web.webstocksumhistory;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webstocksumhistory.WebStockSumHistoryService;
import com.madeu.util.HttpUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebStockSumHistoryController extends ManagerDraftAction{

	@Autowired
	private WebStockSumHistoryService webStockSumHistoryService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	/**
	 * 현재 재고 제품별 거래처 - 상세 리스트 조회 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumhistory/selectListStockSumCompanyHistoryIntro.do")
	public String  selectListStockSumCompanyHistoryIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebStockSumHistoryController  selectListStockSumCompanyHistoryIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumHistoryService.selectListStockSumCompanyHistoryIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebStockSumHistoryController  selectListStockSumCompanyHistoryIntro END");
		return "/web/stocksumhistory/stockSumHistorySelectList";
	}
	

	
	/**
	 * 현재고 상세 리스트 상단 - 제품명, 거래처, 평균입고단가, 재고수량, 재고금액 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumhistory/selectTotalStockSumCompanyHistory.do")
	public ModelAndView selectTotalStockSumCompanyHistory(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumHistoryController selectTotalStockSumCompanyHistory START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumHistoryService.selectTotalStockSumCompanyHistory(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumHistoryController selectTotalStockSumCompanyHistory END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * 현재 재고 제품별 거래처 - 상세 리스트
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumhistory/selectListStockSumCompanyHistory.do")
	public ModelAndView selectListStockSumCompanyHistory(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumHistoryController selectListStockSumCompanyHistory START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumHistoryService.selectListStockSumCompanyHistory(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumHistoryController selectListStockSumCompanyHistory END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}
